export { handler as build } from './lib/commands/build';
export { handler as git } from './lib/commands/git';
export { handler as init } from './lib/commands/init';
export { handler as analyse } from './lib/commands/analyse';
export declare const actions: {
    gitAdd: (argv: import("./lib/types").PropsGlobal, props: {
        files: string[];
    }) => Promise<void>;
    gitCommit: (argv: import("./lib/types").PropsGlobal, props: {
        msg: string;
    }) => Promise<void>;
    gitInit: (argv: import("./lib/types").PropsGlobal) => Promise<void>;
    gitStaged: (argv: import("./lib/types").PropsGlobal, props: Record<string, undefined>) => Promise<string[]>;
    nodeFile: (argv: import("./lib/types").PropsGlobal, props: {
        file: string;
    }) => Promise<void>;
    nodeFolder: (argv: import("./lib/types").PropsGlobal, props: {
        folder: string;
    }) => Promise<void>;
    nodeTemplate: (argv: import("./lib/types").PropsGlobal, props: {
        source: string;
        target?: string | undefined;
        variables: Record<string, import("./lib/actions/node/template").TemplateVariable>;
    }) => Promise<void>;
    npmInit: (argv: import("./lib/types").PropsGlobal, props: {
        settings: {
            [x: string]: string | number | boolean | string[] | Record<string, string>;
        } & {
            scripts?: Record<string, string> | undefined;
            bin?: Record<string, string> | undefined;
            peerDependencies?: string[] | undefined;
        };
    }) => Promise<void>;
    npmInstall: (argv: import("./lib/types").PropsGlobal, props: {
        packages: string[];
        mode: import("./lib/types").NpmInstallMode;
    }) => Promise<void>;
    commitlint: (argv: import("./lib/types").PropsGlobal, props: import("./lib/actions/tools/commitlint").CommitlintProps) => Promise<void>;
    eslint: (argv: import("./lib/types").PropsGlobal, props: import("./lib/actions/tools/eslint").EslintProps) => Promise<void>;
    prettier: (argv: import("./lib/types").PropsGlobal, props: import("./lib/actions/tools/prettier").PrettierProps) => Promise<void>;
};
