"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _path = require("path");

var _toolLib = require("@kettil/tool-lib");

var _access = _interopRequireDefault(require("../cmd/access"));

var _readFile = _interopRequireDefault(require("../cmd/readFile"));

const getDataRecursive = (data, keys) => {
  const key = keys.shift();

  if (key === undefined) {
    return data;
  }

  return (0, _toolLib.isObject)(data) ? getDataRecursive(data[key], keys) : undefined;
};

const getConfig = async (cwd, keyPath) => {
  const configPath = (0, _path.join)(cwd, '.carnarc.json');
  const hasConfigFile = await (0, _access.default)(configPath, 'readable');

  if (!hasConfigFile) {
    // carna config file is not readable
    return undefined;
  }

  const data = await (0, _readFile.default)(configPath, true);
  return typeof keyPath === 'string' ? getDataRecursive(data, keyPath.split('.')) : data;
};

var _default = getConfig;
exports.default = _default;