"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.spinnerBreak = exports.spinnerAction = void 0;

var _toolLib = require("@kettil/tool-lib");

var _ora = _interopRequireDefault(require("ora"));

var _spinnerWarnError = _interopRequireDefault(require("../errors/spinnerWarnError"));

const instance = (0, _ora.default)({
  color: 'white',
  spinner: 'dots'
});

const isSpinning = () => instance.isSpinning;

const start = text => {
  instance.start(text);
};

const stop = (key, text) => {
  if (isSpinning()) {
    instance[key](text);
  }
};

const succeed = p => {
  stop('succeed');
  return p;
};

const fail = error => {
  if (error instanceof _spinnerWarnError.default) {
    stop('warn', error.spinnerText);
  } else {
    stop('fail');
  }

  throw error;
};

const spinnerAction = (action, text) => {
  start(text);
  return action.then(succeed, fail);
};

exports.spinnerAction = spinnerAction;

const spinnerBreak = () => {
  if (isSpinning()) {
    stop('stop');
    return () => instance.start();
  }

  return _toolLib.dummy;
};

exports.spinnerBreak = spinnerBreak;