"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.createBuilder = exports.createHandler = void 0;

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));

var _entries = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/entries"));

var _fromEntries = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/from-entries"));

var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));

var _entries2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/entries"));

var _chalk = require("chalk");

var _executableError = _interopRequireDefault(require("../errors/executableError"));

var _helper = require("../helper");

var _logo = _interopRequireDefault(require("../logo"));

const globalOptions = ['cwd', 'tpl', 'cfg', 'log', 'vvv', 'ci'];

const filterOptions = ([key]) => (0, _includes.default)(globalOptions).call(globalOptions, key);

const filterProps = ([key]) => {
  var _context;

  return !(0, _includes.default)(_context = [...globalOptions, '_', '$0']).call(_context, key);
};

const errorHandler = (argv, error) => {
  if (error instanceof _executableError.default) {
    argv.log.log('');
    argv.log.log((0, _entries.default)(error));
    argv.log.log('');
    (0, _helper.exit)();
  }

  if (error instanceof Error) {
    argv.log.log('');
    argv.log.log((0, _chalk.red)(error.message));
    argv.log.log('');
  }

  throw error;
};

const createHandler = task => async argv => {
  try {
    var _context2, _context3;

    if (!argv.ci) {
      await (0, _logo.default)();
    }

    argv.log.debug(['Paths:', `▸ cwd: ${argv.cwd}`, `▸ cfg: ${argv.cfg}`, `▸ tpl: ${argv.tpl}`, '']);
    const options = (0, _fromEntries.default)((0, _filter.default)(_context2 = (0, _entries2.default)(argv)).call(_context2, filterOptions));
    const props = (0, _fromEntries.default)((0, _filter.default)(_context3 = (0, _entries2.default)(argv)).call(_context3, filterProps));
    await task(options, props);
  } catch (error) {
    errorHandler(argv, error);
  }
};

exports.createHandler = createHandler;

const createBuilder = (command, callback) => yargs => callback(yargs).usage(`Usage: $0 ${command} [options]`).help().version(false).showHelpOnFail(false);

exports.createBuilder = createBuilder;