"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.builder = exports.handler = exports.desc = exports.command = void 0;

var _yargs = require("../cli/yargs");

var _initTask = _interopRequireDefault(require("../tasks/initTask"));

const command = 'init';
exports.command = command;
const desc = 'Initializes the project';
exports.desc = desc;
const args = {
  type: 'boolean',
  default: false,
  group: `${command}-Options:`
};
const handler = (0, _yargs.createHandler)(_initTask.default);
exports.handler = handler;
const builder = (0, _yargs.createBuilder)(command, yargs => yargs.options({
  package: { ...args,
    alias: 'p',
    desc: 'Project is created as a package'
  },
  cli: { ...args,
    alias: 'c',
    implies: 'package',
    desc: 'Extends the package with CLI features'
  },
  github: {
    type: 'string',
    desc: 'Github username',
    group: `${command}-Options:`
  },
  // conflict with cli
  // react: { ...args, alias: 'r', default: undefined, desc: 'React will be installed', },
  noCommit: { ...args,
    desc: 'No initial commit is executed at the end'
  }
}));
exports.builder = builder;