"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _path = require("path");

var _packageLoad = _interopRequireDefault(require("../actions/npm/packageLoad"));

var _babel = _interopRequireDefault(require("../actions/tools/babel"));

var _tsc = _interopRequireDefault(require("../actions/tools/tsc"));

var _webpack = _interopRequireDefault(require("../actions/tools/webpack"));

var _spinner = require("../cli/spinner");

var _access = _interopRequireDefault(require("../cmd/access"));

var _npmHookTask = _interopRequireDefault(require("./subTasks/npmHookTask"));

const buildTask = async argv => {
  await (0, _npmHookTask.default)(argv, {
    task: 'build',
    type: 'pre'
  });
  const isPrivate = await (0, _packageLoad.default)(argv, {
    key: 'private'
  });
  const hasTypescriptConfig = await (0, _access.default)((0, _path.join)(argv.cwd, 'tsconfig.json'), 'readable');

  if (hasTypescriptConfig && isPrivate !== true) {
    await (0, _spinner.spinnerAction)((0, _tsc.default)(argv, {
      mode: 'type-create'
    }), 'Typescript');
  }

  await (0, _spinner.spinnerAction)((0, _babel.default)(argv), 'Babel');
  await (0, _spinner.spinnerAction)((0, _webpack.default)(argv), 'Webpack');
  await (0, _npmHookTask.default)(argv, {
    task: 'build',
    type: 'post'
  });
};

var _default = buildTask;
exports.default = _default;