"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));

var _toolLib = require("@kettil/tool-lib");

var _depcheck = _interopRequireDefault(require("../actions/tools/depcheck"));

var _config = _interopRequireDefault(require("../cli/config"));

var _spinner = require("../cli/spinner");

var _dependencyError = _interopRequireDefault(require("../errors/dependencyError"));

var _npmHookTask = _interopRequireDefault(require("./subTasks/npmHookTask"));

const depsTask = async argv => {
  try {
    const configIgnorePackages = await (0, _config.default)(argv.cwd, 'deps.ignore.packages');
    const ignorePackages = (0, _toolLib.isArray)(configIgnorePackages) ? (0, _filter.default)(configIgnorePackages).call(configIgnorePackages, v => typeof v === 'string') : [];
    await (0, _npmHookTask.default)(argv, {
      task: ['deps'],
      type: 'pre'
    });
    await (0, _spinner.spinnerAction)((0, _depcheck.default)(argv, ignorePackages), 'Dependency verification');
    await (0, _npmHookTask.default)(argv, {
      task: ['deps'],
      type: 'post'
    });
  } catch (error) {
    if (error instanceof _dependencyError.default) {
      argv.log.log(error.list);
      return;
    }

    throw error;
  }
};

var _default = depsTask;
exports.default = _default;