"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _trim = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/trim"));

var _gitCommitTask = _interopRequireDefault(require("./subTasks/gitCommitTask"));

var _gitMessageTask = _interopRequireDefault(require("./subTasks/gitMessageTask"));

var _gitPushTask = _interopRequireDefault(require("./subTasks/gitPushTask"));

var _npmHookTask = _interopRequireDefault(require("./subTasks/npmHookTask"));

const gitTask = async (argv, {
  edit,
  hook
}) => {
  await (0, _npmHookTask.default)(argv, {
    task: 'git',
    type: 'pre'
  });

  switch (hook) {
    case 'commit':
      await (0, _npmHookTask.default)(argv, {
        task: ['git', 'commit'],
        type: 'pre'
      });
      await (0, _gitCommitTask.default)(argv);
      await (0, _npmHookTask.default)(argv, {
        task: ['git', 'commit'],
        type: 'post'
      });
      break;

    case 'msg':
      if (typeof edit !== 'string' || (0, _trim.default)(edit).call(edit) === '') {
        throw new Error(`Argument "edit" is required at hook "${hook}"`);
      }

      await (0, _npmHookTask.default)(argv, {
        task: ['git', 'msg'],
        type: 'pre'
      });
      await (0, _gitMessageTask.default)(argv, {
        edit
      });
      await (0, _npmHookTask.default)(argv, {
        task: ['git', 'msg'],
        type: 'post'
      });
      break;

    case 'push':
      await (0, _npmHookTask.default)(argv, {
        task: ['git', 'push'],
        type: 'pre'
      });
      await (0, _gitPushTask.default)(argv);
      await (0, _npmHookTask.default)(argv, {
        task: ['git', 'push'],
        type: 'post'
      });
      break;

    default:
      throw new Error(`The hook "${hook}" is unknown`);
  }

  await (0, _npmHookTask.default)(argv, {
    task: 'git',
    type: 'post'
  });
};

var _default = gitTask;
exports.default = _default;