"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _set = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set"));

var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _startsWith = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/starts-with"));

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));

var _promises = require("fs/promises");

var _path = require("path");

var _toolLib = require("@kettil/tool-lib");

var _config = _interopRequireDefault(require("../../cli/config"));

const ignoreFolders = new _set.default(['shared', 'type']);
const specialFolders = ['unit', 'integration', 'e2e'];
const defaultCoverageProjects = ['unit', 'integration'];

const getTestProjects = async ({
  cwd
}, selectedProjects, withCoverage) => {
  var _context, _context2;

  const files = await (0, _promises.readdir)((0, _path.join)(cwd, 'tests'), {
    withFileTypes: true
  });
  const folders = (0, _filter.default)(_context = (0, _map.default)(_context2 = (0, _filter.default)(files).call(files, file => {
    var _context3;

    return file.isDirectory() && !(0, _startsWith.default)(_context3 = file.name).call(_context3, '.');
  })).call(_context2, folder => folder.name)).call(_context, folder => !ignoreFolders.has(folder));
  const projects = [...(0, _filter.default)(specialFolders).call(specialFolders, folder => (0, _includes.default)(folders).call(folders, folder)), ...(0, _filter.default)(folders).call(folders, folder => !(0, _includes.default)(specialFolders).call(specialFolders, folder))];

  if (selectedProjects === undefined || selectedProjects.length === 0) {
    if (withCoverage) {
      const configCoverageProjects = await (0, _config.default)(cwd, 'test.coverage.projects');
      return (0, _toolLib.isArray)(configCoverageProjects) && configCoverageProjects.length > 0 ? (0, _filter.default)(configCoverageProjects).call(configCoverageProjects, v => typeof v === 'string') : defaultCoverageProjects;
    }

    return projects;
  }

  const unknownProjects = (0, _filter.default)(selectedProjects).call(selectedProjects, v => !(0, _includes.default)(projects).call(projects, v));

  if (unknownProjects.length > 0) {
    throw new Error(`The following test project(s) are unknown: ${unknownProjects.join(', ')}`);
  }

  return (0, _filter.default)(projects).call(projects, v => (0, _includes.default)(selectedProjects).call(selectedProjects, v));
};

var _default = getTestProjects;
exports.default = _default;