"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _toolLib = require("@kettil/tool-lib");

var _packageLoad = _interopRequireDefault(require("../../actions/npm/packageLoad"));

var _run = _interopRequireDefault(require("../../actions/npm/run"));

var _spinner = require("../../cli/spinner");

const npmHookTask = async (argv, {
  task,
  type
}) => {
  const scripts = await (0, _packageLoad.default)(argv, {
    key: 'scripts'
  });
  const script = `${type}carna:${(0, _toolLib.isArray)(task) ? task.join(':') : task}`;

  if ((0, _toolLib.isObject)(scripts) && typeof scripts[script] === 'string') {
    await (0, _spinner.spinnerAction)((0, _run.default)(argv, {
      script
    }), `Run npm script: ${script}`);
  } else {
    argv.log.info(`The NPM script "${script}" is not defined`);
  }
};

var _default = npmHookTask;
exports.default = _default;