"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _jest = _interopRequireDefault(require("../actions/tools/jest"));

var _spinner = require("../cli/spinner");

var _getTestProjects = _interopRequireDefault(require("./helpers/getTestProjects"));

var _npmHookTask = _interopRequireDefault(require("./subTasks/npmHookTask"));

const testTask = async (argv, props) => {
  await (0, _npmHookTask.default)(argv, {
    task: 'test',
    type: 'pre'
  });
  const projects = await (0, _getTestProjects.default)(argv, props.project, props.coverage);

  if (props.watch || props.coverage) {
    /* eslint-disable-next-line no-restricted-syntax */
    for (const project of projects) {
      /* eslint-disable-next-line no-await-in-loop */
      await (0, _npmHookTask.default)(argv, {
        task: ['test', project],
        type: 'pre'
      });
    }

    if (props.coverage) {
      await (0, _spinner.spinnerAction)((0, _jest.default)(argv, { ...props,
        project: projects
      }), 'Jest: coverage');
    } else {
      await (0, _jest.default)(argv, { ...props,
        project: projects
      });
    }
    /* eslint-disable-next-line no-restricted-syntax */


    for (const project of projects) {
      /* eslint-disable-next-line no-await-in-loop */
      await (0, _npmHookTask.default)(argv, {
        task: ['test', project],
        type: 'post'
      });
    }
  } else {
    /* eslint-disable-next-line no-restricted-syntax */
    for (const project of projects) {
      /* eslint-disable no-await-in-loop */
      await (0, _npmHookTask.default)(argv, {
        task: ['test', project],
        type: 'pre'
      });
      await (0, _spinner.spinnerAction)((0, _jest.default)(argv, { ...props,
        project
      }), `Jest: ${project}`);
      await (0, _npmHookTask.default)(argv, {
        task: ['test', project],
        type: 'post'
      });
      /* eslint-enable no-await-in-loop */
    }
  }

  await (0, _npmHookTask.default)(argv, {
    task: 'test',
    type: 'post'
  });
};

var _default = testTask;
exports.default = _default;