import { Logger } from './cli/logger';
export declare type NpmInstallMode = 'dev' | 'optional' | 'prod';
export declare type PropsGlobal = {
    readonly cwd: string;
    readonly tpl: string;
    readonly cfg: string;
    readonly log: Logger;
    readonly vvv: boolean;
    readonly ci: boolean;
};
export declare type Action<Props extends Record<string, unknown> | unknown[] | undefined = undefined, ActionReturn = void> = Props extends undefined ? (argv: PropsGlobal) => Promise<ActionReturn> : Props extends unknown[] ? (argv: PropsGlobal, ...props: Props) => Promise<ActionReturn> : (argv: PropsGlobal, props: Props) => Promise<ActionReturn>;
export declare type Task<Props extends Record<string, unknown> | unknown[] | undefined = undefined, ActionReturn = void> = Props extends undefined ? (argv: PropsGlobal) => Promise<ActionReturn> : Props extends unknown[] ? (argv: PropsGlobal, ...props: Props) => Promise<ActionReturn> : (argv: PropsGlobal, props: Props) => Promise<ActionReturn>;
export declare type LicenseCompatibilities = Record<string, string[]>;
export declare type LicenseHeuristics = Record<string, RegExp>;
export declare type LicensePackages = Record<string, Record<string, string>>;
export declare type LicensePackageInfo = {
    path: string;
    name: string;
    license: string | 'UNKNOWN';
    version: string | 'UNKNOWN';
};
